Attribute VB_Name = "Module1"
Option Explicit ' 230524
Sub ShowNewData()
Attribute ShowNewData.VB_ProcData.VB_Invoke_Func = "a\n14"
  
  If ActiveSheet.Name = "000" Then
    MsgBox "This function can not be done on this Protected Template Worksheet.", vbCritical + vbOKOnly, "Enter New Data Error"
    Exit Sub
  End If
  
  NewData.Show
End Sub
Sub FindFirstFreeCell()
  Dim X As String, I As Integer
  
  ActiveCell.SpecialCells(xlLastCell).Select ' find last
  X = ActiveCell.Row
  If X = 1 Then Range("A2").Select: Exit Sub
    
  For I = X To 2 Step -1  ' skip empty cells on the bottom
    
    If Trim(Range("A" + Trim(Str(I))).Value) <> "" Then
      Range("A" + Trim(Str(I + 1))).Select
      Exit For
    End If
    
  Next
  
  If I = 1 Then Range("A2").Select
End Sub
Sub ShowFindData()
Attribute ShowFindData.VB_ProcData.VB_Invoke_Func = "z\n14"
  FindData.Show
End Sub
Sub ShowNewWorkSheet()
Attribute ShowNewWorkSheet.VB_ProcData.VB_Invoke_Func = "q\n14"
  NewWorkSheet.Show
End Sub

Sub Auto_Open() ' check/update version info at start
Attribute Auto_Open.VB_ProcData.VB_Invoke_Func = " \n14"
 Dim Ver As String, Dt As String, I As Integer

 Ver = "1.33": Dt = "May 24, 2023"

 Application.Interactive = False ' if not here opened worksheet may not be active
 Application.Interactive = True  ' if not here opened worksheet may not be active
 
 If InStr(Worksheets("000").Range("F3"), Ver + ",") Then  ' do nothing if version is current
    Sheets("000").Select
    Range("A1").Select
    ActiveWorkbook.Saved = True
    If Sheets.Count > 1 Then DoEvents: FindData.Show Else NewWorkSheet.Show  ' !! DoEvents=TEST no new version
   Exit Sub
 End If

 If InStr(Sheets("000").Range("F3"), "1.0") Then ' update template sheet if version is 1.0 or 1.01
    Worksheets("000").Range("A1:F13").Copy
    Sheets.Add
    Selection.PasteSpecial Paste:=xlPasteColumnWidths, Operation:=xlNone, SkipBlanks:=False, Transpose:=False
    ActiveSheet.Paste
    Range("C2").ColumnWidth = 10
    Range("A3") = "This is a Template Worksheet, do not remove or rename this WorkSheet !"
    Range("A3").Font.ColorIndex = 3
    Range("E13") = "Column C: Location, max 10 characters"
    Range("A15") = "Worksheet and VB Macros created by Hkan Hintze, Sweden"
    Range("A15").HorizontalAlignment = xlLeft
    Range("F15").Select
    ActiveSheet.Hyperlinks.Add Anchor:=Selection, Address:="mailto:hahi@telai.com?subject=TekPartsManager", TextToDisplay:="Email: hahi@ telia.com"
    Range("E17") = "Check here for updates: "
    Range("E17").HorizontalAlignment = xlRight
    Range("F17").Select
    ActiveSheet.Hyperlinks.Add Anchor:=Selection, Address:="http://www.hakanh.com/dl/PartsManager", TextToDisplay:="http://www.hakanh.com/dl/PartsManager"
    Sheets("000").Name = "x"
    ActiveSheet.Name = "000"
    Application.DisplayAlerts = False
    Sheets("x").Delete
    Application.DisplayAlerts = True
    Sheets("000").Move Before:=Sheets(1)
 Else  ' update version info
   Sheets("000").Unprotect
   Sheets("000").Select
 End If

 If InStr(Sheets("000").Range("F3"), "1.0") Or InStr(Sheets("000").Range("F3"), "1.1") Then 'Change ea to Qty on all sheets if 1.1 or lower !
   Range("B1") = "Qty"
   
   For I = 1 To Sheets.Count
      Sheets(Sheets(I).Name).Range("B1") = "Qty"
   Next I
   
 End If
  
 Sheets("000").Range("F3") = "TekParts.xls " + Ver + "," + " " + Dt
 Sheets("000").Protect DrawingObjects:=True, Contents:=True, Scenarios:=True
 Sheets("000").EnableSelection = xlNoRestrictions
 Range("A1").Select
 DoEvents
 If Sheets.Count > 1 Then FindData.Show Else NewWorkSheet.Show
End Sub

